*
*     EW O(alpha^3) leading correction to \rho
*     
      complex*16 function drho_at3_as0 (alpha,alphas,mz,mw,mh,mtp)
      implicit none!
      real*8 ctw2,stw2,gfermi,xt,dht,nc
      real*8 alpha,alphas,mz,mw,mh,mtp
      real*8 c1,c2,c3,c4,c5,c6,c7,c8,c9,c10,c11,c12
      include "constants.h"

      nc = 3
      ctw2 = mw**2/mz**2
      stw2 = 1-ctw2
      gfermi = pi*alpha/sqrt(2d0)/stw2/mw**2
      xt = sqrt(2d0)*gfermi*mtp**2/16/pi**2

*     M. Faisst et al., hep-ph/0302275      
*     Eq.(18), p.9
      c1 = 95.92d0
      c2 = -111.98d0
      c3 = 8.099d0
      c4 = 9.36d0
      c5 = 7.27d0
      c6 = -15.60d0
      dht = mh/mtp-1
      
      drho_at3_as0 =
     &     c1 + c2*dht + c3*dht**2 + c4*dht**3 + c5*dht**4 + c6*dht**5

*     J.J. van der Bij et al., hep-ph/0011373      
*     Eq.(9), p.6
      c1  = 68d0
      c2  = 729d0
      c3  = 36d0
      c4  = 96d0
      c5  = 6d0
      c6  = -612d0
      c7  = 324d0
      c8  = -72d0
      c9  = -6572d0/15
      c10 = -4374d0/5
      c11 = 1472d0/15
      c12 = 440d0

c$$$      drho_at3_as0 =
c$$$     &  c1 + c2*s2 + c3*d3 + c4*z2*ln2 + c5*z2 + c6*z3 + c7*z4 + c8*b4
c$$$     &     + (c9 + c10*s2 + c11*z2 + c12*z3)*nc
*     drho_at3_as0 = 10.1467 + 24.3668*nc ! paper number
*     drho_at3_as0 = 10.1467 + 24.3668*nc | real life
*     print *, drho_at3_as0
      
      drho_at3_as0 = nc*xt**3*drho_at3_as0

      return
      end
