#ifndef PROCESS_H
#define PROCESS_H

#include <string>
#include <vector>
#include "Vec4.h"

namespace SANC {

class Info;

class Particle {
public:
   Particle(int id=0,double spin=9.,int col1=0,int col2=0):id(id),spin(spin),col1(col1),col2(col2){}
   int id,col1,col2;
   double spin;
   Vec4 p;
};

class Event {
public:
   double weight() const {return weightProc;}
   Vec4& P(int part) {return particles[part].p;}
   double weightProc;
   std::vector<Particle> particles;
};

class Process {
public:
   Process(Info & _info);
   int idProc;
   int  kDimBorn, kDimVirt, kDimHard;
   double Mf1,Mf2,Mf3,Mf4;
   double Mf1_2,Mf2_2,Mf3_2,Mf4_2;
   double dm,sm;
   std::vector<int> idup;
   std::string procName,arXiv;
   Event event;
private:
   Info & info;
};

}

#endif // PROCESS_H
