      function Pair_16(p,q)
      implicit none!
      real*8 Pair_16
      real*16 p(5),q(5)
      Pair_16 = p(4)*q(4)-p(1)*q(1)-p(2)*q(2)-p(3)*q(3)
      return
      end

      function Pair(p,q)
      implicit none!
      real*8 Pair
      real*8 p(5),q(5)
      Pair = p(4)*q(4)-p(1)*q(1)-p(2)*q(2)-p(3)*q(3)
      return
      end

      function MandelstamS(p,q)
      implicit none!
      real*8 p(5),q(5)
      real*8 Pair,MandelstamS
      MandelstamS = 2d0*Pair(p,q)
      return
      end


      function Exp_IArgAA(p,q)
      implicit none!
      real*8 p(5),q(5)
      complex*16 Exp_IArgAA
      real*8 pPlus,qPlus,nx,ny,na
      pPlus=p(4)+p(3)
      qPlus=q(4)+q(3)
      nx=p(1)*qPlus-q(1)*pPlus
      ny=p(2)*qPlus-q(2)*pPlus
      na=hypot(nx,ny)
      if (.not.(na.gt.0d0)) then
        nx=1d0
        ny=0d0
      else
        nx=nx/na
        ny=ny/na
      endif
      if (p(4).lt.0) then
        if (q(4).LT.0) then
          Exp_IArgAA = cmplx(-nx,-ny)
        else
          Exp_IArgAA = cmplx(ny,-nx)
        endif
      else
        if (q(4).lt.0) then
          Exp_IArgAA = cmplx(ny,-nx)
        else
          Exp_IArgAA = cmplx(nx,ny)
        endif
      endif
      return
      end

      function Exp_IArgBB(p,q)
      implicit none!
      real*8 p(5),q(5)
      complex*16 Exp_IArgBB
      complex*16 Exp_IArgAA
      Exp_IArgBB=-conjg(Exp_IArgAA(p,q))*sign(1d0,p(4))*sign(1d0,q(4));
      return
      end

      function SpAA(p,q)
      implicit none!
      real*8 p(5),q(5)
      complex*16 SpAA
      real*8 MandelstamS
      complex*16 Exp_IArgAA
      SpAA=sqrt(abs(MandelstamS(p,q)))*Exp_IArgAA(p,q)
      return
      end

      function SpBB(p,q)
      implicit none!
      real*8 p(5),q(5)
      complex*16 SpBB
      real*8 MandelstamS
      complex*16 Exp_IArgBB
      SpBB=sqrt(abs(MandelstamS(p,q)))*Exp_IArgBB(p,q)
      return
      end

      subroutine S_Assoc(p,q,Assoc)
      implicit none!
      real*8 p(5),q(5)
      real*8 Pair,pq,Assoc(5),med
      real*8 mp,mq,det
      mp = p(5)
      mq = q(5)
      if (mp.eq.0d0) then
        Assoc = p
        return
      endif
      if ((p(1).eq.0d0).and.(p(2).eq.0d0)) then
        pq = abs(p(4))*(q(4)*sign(1d0,p(4))-q(3)*sign(1d0,p(3))+q(3)*sign(1d0,p(3))*(mp**2/2d0/p(4)**2+mp**4/8d0/p(4)**4))
      else
        pq = Pair(p,q)
      endif
      if (mq.eq.0d0) then
        Assoc = p -(mp**2/(2d0*pq))*q
        Assoc(4) = sign(sqrt(Assoc(3)**2+Assoc(2)**2+Assoc(1)**2),Assoc(4))
      else
        det = sign(sqrt(pq**2-mp**2*mq**2),pq)
        Assoc = ((det+pq)/(2d0*det))*p-(mp**2/(2d0*det))*q
      endif
      Assoc(5)=0d0
      return
      end

      subroutine S_Assoc_16(p,q,Assoc)
      implicit none!
      real*16 p(5),q(5)
      real*8 Pair_16,pq,Assoc(5),med
      real*16 mp,mq,det
      mp = p(5)
      mq = q(5)
      if (mp.eq.0q0) then
        Assoc = p
        return
      endif
      pq = Pair_16(p,q)
      if (mq.eq.0q0) then
        Assoc = p -(mp**2/(2q0*pq))*q
!        Assoc(4) = sign(dsqrt(Assoc(3)**2+Assoc(2)**2+Assoc(1)**2),Assoc(4))
!        if ((Assoc(1).eq.0q0).and.(Assoc(2).eq.0q0)) then
!            med = (abs(Assoc(3))+abs(Assoc(4)))/2q0
!            Assoc(3) = sign(med,Assoc(3))
!            Assoc(4) = sign(med,Assoc(4))
!        endif
        Assoc(5)=0d0
        return
      else
        det = sign(sqrt(pq**2-mp**2*mq**2),1q0*pq)
        Assoc = ((det+pq)/(2q0*det))*p-(mp**2/(2q0*det))*q
        Assoc(5)=0d0
        endif
      return
      end

      subroutine S_Ref(p,Ref)
      implicit none!
      real*8 p(5),mp
      real*8 Ref(5)
      mp=p(5)
      Ref = -p
      if (mp.eq.0d0) then
        Ref(4)=p(4)
        return
      else
        Ref(4)=sign(sqrt(p(1)**2+p(2)**2+p(3)**2),p(4))
        Ref(5)=0d0
        return
      endif
      return
      end

      subroutine S_Assoc1(p,Assoc)
      implicit none!
      real*8 p(5)
      real*8 Assoc(5),q(5)
        call S_Ref(p,q)
        call S_Assoc(p,q,Assoc)
        return
      end

      subroutine S_CC(p1,p2,msign,CC)
      implicit none!
      real*8 p1(5),p2(5)
      complex*16 CC(2,2)
      real*8 msign
      complex*16 SpAA,SpBB,SpAA16,SpBB16
      real*8 m
      real*8 k1(5),k2(5),k12(5),q1(5),q2(5)
      complex*16 inv_SpAA_k2_k12,inv_SpBB_k2_k12
      real*8 MandelstamS
      complex*16 Exp_IArgAA
      m = sign(p1(5),msign)
      call S_Ref(p1,q1)
      call S_Assoc(p1,q1,k1)
      call S_Ref(p2,q2)
      call S_Assoc(p2,q2,k2)
      call S_Assoc(p1,p2,k12)
      inv_SpAA_k2_k12=1d0/SpAA(k2,k12)
      inv_SpBB_k2_k12=1d0/SpBB(k2,k12)
      CC(1,1) = SpAA(k2,k1)*inv_SpAA_k2_k12
      CC(1,2) = m*SpAA(k2,q1)*inv_SpAA_k2_k12/SpAA(k1,q1)
      CC(2,1) = m*SpBB(k2,q1)*inv_SpBB_k2_k12/SpBB(k1,q1)
      CC(2,2) = SpBB(k2,k1)*inv_SpBB_k2_k12
      return
      end

      function chi(Is)
      implicit none!
      include 's2n_declare.h'
      complex*16 chi
      real*8 Is
      chi = Is/cmplx(Is-mz**2,mz*wz)
      return
      end

      function DLL2_3(Is)
      implicit none!
      include 's2n_declare.h'
      complex*16 DLL2_3
      real*8 cw,sw,tanw,csc2w
      real*8 eQ2,eQ3,eL2,eL3,eR2,eR3
      complex*16 chi
      real*8 Is
      cw = mw/mz
      sw = sqrt(1d0-cw**2)
      csc2w = 1d0/(2d0*sw*cw)
      tanw=sw/cw
      eQ2 = -1d0
      eQ3 = -1d0
      eR2 = -eQ2*tanw
      eR3 = -eQ3*tanw
      eL2 = -csc2w+eR2
      eL3 = -csc2w+eR3
      DLL2_3 = (eQ2*eQ3+eL2*eL3*chi(Is))/Is
      return
      end

      function DRR2_3(Is)
      implicit none!
      include 's2n_declare.h'
      complex*16 DRR2_3
      real*8 cw,sw,tanw,csc2w
      real*8 eQ2,eQ3,eL2,eL3,eR2,eR3
      complex*16 chi
      real*8 Is
      cw = mw/mz
      sw = sqrt(1d0-cw**2)
      csc2w = 1d0/(2d0*sw*cw)
      tanw=sw/cw
      eQ2 = -1d0
      eQ3 = -1d0
      eR2 = -eQ2*tanw
      eR3 = -eQ3*tanw
      eL2 = -csc2w+eR2
      eL3 = -csc2w+eR3
      DRR2_3 = (eQ2*eQ3+eR2*eR3*chi(Is))/Is
      return
      end

      function DRL2_3(Is)
      implicit none!
      include 's2n_declare.h'
      complex*16 DRL2_3
      real*8 cw,sw,tanw,csc2w
      real*8 eQ2,eQ3,eL2,eL3,eR2,eR3
      complex*16 chi
      real*8 Is
      cw = mw/mz
      sw = sqrt(1d0-cw**2)
      csc2w = 1d0/(2d0*sw*cw)
      tanw=sw/cw
      eQ2 = -1d0
      eQ3 = -1d0
      eR2 = -eQ2*tanw
      eR3 = -eQ3*tanw
      eL2 = -csc2w+eR2
      eL3 = -csc2w+eR3
      DRL2_3 = (eQ2*eQ3+eR2*eL3*chi(Is))/Is
      return
      end

      function DRL3_2(Is)
      implicit none!
      include 's2n_declare.h'
      complex*16 DRL3_2
      real*8 cw,sw,tanw,csc2w
      real*8 eQ2,eQ3,eL2,eL3,eR2,eR3
      complex*16 chi
      real*8 Is
      cw = mw/mz
      sw = sqrt(1d0-cw**2)
      csc2w = 1d0/(2d0*sw*cw)
      tanw=sw/cw
      eQ2 = -1d0
      eQ3 = -1d0
      eR2 = -eQ2*tanw
      eR3 = -eQ3*tanw
      eL2 = -csc2w+eR2
      eL3 = -csc2w+eR3
      DRL3_2 = (eQ2*eQ3+eL2*eR3*chi(Is))/Is
      return
      end
