************************************************************************
* This is the FORTRAN module (nc_br_1212_1212) to calculate EW Born
* cross section and soft photon Bremsstrahlung
* for the Bhabha (el^+ + el^- -> el^+ + el^-) process.
*
* It is produced by s2n package of SANC (v1.10) Project.
* Copyright (C), SANC Project Team, 2002-2017.
*
* http://sanc.jinr.ru/
* http://pcphsanc.cern.ch/
* E-mail: <sanc@jinr.ru>
************************************************************************
      subroutine nc_br_12_12__12_12 (qs,ts,us,born,soft,hard)
      implicit none!
      include 's2n_declare.h'

      integer iborn_
      real*8 lnlaom,cpl,cmi
      real*8 softisr,softfsr,softifi,presoft
      real*8 kappaz
      complex*16 chizs,chizsc
      complex*16 chizt
      real*8 betaselel,ibetaselel,born1

      soft = 0d0
      hard = 0d0
      softisr = 0d0
      softfsr = 0d0
      softifi = 0d0

      cmz2 = mz2

      s = -qs
      t = -ts
      u = -us

      iborn_ = iborn
      iborn  = 1
      call nc_si_12_12__12_12 (s,t,u,born)
      iborn  = iborn_
      if (born.ne.born) print *,'Born NAN!!!',s,t,u

      if (iborn.eq.1) return

      lnlaom = log(4d0*omega**2/tlmu2)

      presoft=
     & +1d0/pi*alpha*qel**2*born*(-2*log(-1d0/qs*mel**2)
     & -log(-1d0/qs*mel**2)**2-log(-1d0/qs*us)**2+log(-1d0/qs*ts)**2+2*d
     & dilog(-1d0/qs*us)
     & -2*ddilog(-1d0/qs*ts))+pi*alpha*qel**2*born*(-2d0/3)
     & +lnlaom/pi*alpha*qel**2*born*(-2-2*log(-1d0/qs*mel**2)
     & +2*log(ts/us))

      if (iqed.ge.1) then
          soft = presoft
      endif

      soft = soft*cfprime
      if (soft.ne.soft) print *,'Soft NAN!!!',s,t,u

      return
      end
