************************************************************************
* sanc_cc_v1.70 package.
************************************************************************
* File (nc_ff_12_12__12_12.F) is created on Вт ноя 14 04:10:27 MSK 2017.
************************************************************************
* This is the FORTRAN module (nc_ff_12_12__12_12) to calculate 1-loop EW
* form factors for the Bhabha (el^+ + el^- -> el^+ + el^-) process.
*
* It is produced by s2n package of SANC (v1.10) Project.
* Copyright (C), SANC Project Team, 2002-2017.
*
* http://sanc.jinr.ru/
* http://pcphsanc.cern.ch/
* E-mail: <sanc@jinr.ru>
************************************************************************
      subroutine nc_ff_12_12__12_12 (qs,ts,us)
      implicit none!
#include "s2n_declare.h"

      complex*16 ff_qed_ll,ff_qed_lq,ff_qed_ql,ff_qed_qq,ff_qed_ld
      complex*16 ff_qed_qd,ff_ew_ll,ff_ew_ld,ff_ew_lq,ff_ew_ql,ff_ew_qq
      complex*16 ff_ew_qd,ff_qed_gg
      real*8 isr,ifi,fsr

      real*8 a0fel,a0fw,a0fz,a0fh
      real*8 lnlaelm
      complex*16 b0fqszc,b0fqscc,b0ftscc,b0fuscc,b0fqsww,b0fqszz,b0fqsz
     & h
      complex*16 c0elelqszelc,c0irelelqs,c0elelqscelc,c0irelelts,c0irel
     & elus,c0celtsczel,c0celusczel,c0ccqswcw,c0ccqszcz,c0ccqscwc,c0ccqs
     & czc,c0cctscwc,c0cctsczc,c0ccusczc
      complex*16 d0ccccqstswcwc,d0ccccqstszczc,d0ccccqsuszczc
      complex*16 jaaqstselel,jaaqsuselel,javqstselelz,javqsuselelz
      real*8 pxx2zqsc
      complex*16 propzqs,propizqs

      common/unibos_bos/za1bos,zmzzzbos,zmwzwbos,zmhzhbos,deltarhobos
      common/unibos_fer/za1fer,zz1fer,zh1fer,zw1fer,zmsqrfer,
     & zmzzzfer,zmwzwfer,zmhzhfer,deltarhofer,tadfer
      common/unipro_fer/caldzfer,caldwfer,pizgfer,piggfer

      common/keys/igzm2

      cmz2 = mz2
      if (igzm2.eq.0) then
         cmz2 = rzm2
      endif

      propizqs = (cmz2+qs)
      propzqs = 1d0/propizqs
      a0fel = log(relm2/thmu2) - 1d0
      a0fw = log(rwm2/thmu2) - 1d0
      a0fz = log(rzm2/thmu2) - 1d0
      a0fh = log(rhm2/thmu2) - 1d0
      lnlaelm = log(relm2/tlmu2)
      b0fqszc = b0f(qs,thmu2,zm2,cm2)
      b0fqscc = b0f(qs,thmu2,cm2,cm2)
      b0ftscc = b0f(ts,thmu2,cm2,cm2)
      b0fuscc = b0f(us,thmu2,cm2,cm2)
      b0fqsww = b0f(qs,thmu2,wm2,wm2)
      b0fqszz = b0f(qs,thmu2,zm2,zm2)
      b0fqszh = b0f(qs,thmu2,zm2,hm2)
      c0elelqszelc = c01(-relm2,-relm2,qs,zm2,elm2,cm2)
      c0irelelqs = c0ir(tlmu2,elm2,elm2,qs)
      c0elelqscelc = c01(-relm2,-relm2,qs,cm2,elm2,cm2)
      c0irelelts = c0ir(tlmu2,elm2,elm2,ts)
      c0irelelus = c0ir(tlmu2,elm2,elm2,us)
      c0celtsczel = c01(0d0,-relm2,ts,cm2,zm2,elm2)
      c0celusczel = c01(0d0,-relm2,us,cm2,zm2,elm2)
      c0ccqswcw = c01(0d0,0d0,qs,wm2,cm2,wm2)
      c0ccqszcz = c01(0d0,0d0,qs,zm2,cm2,zm2)
      c0ccqscwc = c01(0d0,0d0,qs,cm2,wm2,cm2)
      c0ccqsczc = c01(0d0,0d0,qs,cm2,zm2,cm2)
      c0cctscwc = c01(0d0,0d0,ts,cm2,wm2,cm2)
      c0cctsczc = c01(0d0,0d0,ts,cm2,zm2,cm2)
      c0ccusczc = c01(0d0,0d0,us,cm2,zm2,cm2)
      d0ccccqstswcwc = d040(qs,ts,wm2,cm2)
      d0ccccqstszczc = d040(qs,ts,zm2,cm2)
      d0ccccqsuszczc = d040(qs,us,zm2,cm2)
      jaaqstselel = jaa(qs,ts,elm2,elm2)
      jaaqsuselel = jaa(qs,us,elm2,elm2)
      javqstselelz = jav(qs,ts,elm2,elm2,zm2)
      javqsuselelz = jav(qs,us,elm2,elm2,zm2)
      pxx2zqsc = (2*mz**2)+(qs)

      ff_qed_gg =
     & -za1fer+stw**2*piggfer

      ff_qed_ll =
     & +stw**2*(-2*qel**2)
     & +jaaqstselel*dreal(propizqs)*stw**4*cfscheme*(8*ctw**2*qel**4*ts/
     & us-8*ctw**2*qel**4*ts**2/us**2)
     & +jaaqsuselel*dreal(propizqs)*stw**4*cfscheme*(-8*ctw**2*qel**4/ts
     & **2*us**2+8*ctw**2*qel**4/ts*us)
     & +javqstselelz*stw**2*(4*qel**2*ts)
     & +javqstselelz*dreal(propizqs)*stw**2*(2*qel**2*ts/us**2*mz**2+2*q
     & el**2*ts/us-2*qel**2*ts**2/us**2-4*qel**2*vmael*ts/us**2*mz**2-4*
     & qel**2*vmael*ts/us+4*qel**2*vmael*ts**2/us**2+4*qel**2*vmael**2*t
     & s/us**2*mz**2+4*qel**2*vmael**2*ts/us-4*qel**2*vmael**2*ts**2/us*
     & *2)
     & +javqsuselelz*stw**2*(-4*qel**2*us)
     & +javqsuselelz*dreal(propizqs)*stw**2*(-4*qel**2*vmael/ts**2*us*mz
     & **2+4*qel**2*vmael/ts**2*us**2-4*qel**2*vmael/ts*us+4*qel**2*vmae
     & l**2/ts**2*us*mz**2-4*qel**2*vmael**2/ts**2*us**2+4*qel**2*vmael*
     & *2/ts*us)
     & +c0elelqszelc*dreal(propizqs)*stw**2*(-4*qel**2/us*mz**2-4*qel**2
     & -4*qel**2*ts/us**2*mz**2+4*qel**2*ts**2/us**2+8*qel**2*vmael/ts**
     & 2*us*mz**2-8*qel**2*vmael/ts**2*us**2+8*qel**2*vmael/ts*mz**2+8*q
     & el**2*vmael/us*mz**2+16*qel**2*vmael+8*qel**2*vmael*ts/us**2*mz**
     & 2-8*qel**2*vmael*ts**2/us**2-8*qel**2*vmael**2/ts**2*us*mz**2+8*q
     & el**2*vmael**2/ts**2*us**2-8*qel**2*vmael**2/ts*mz**2-8*qel**2*vm
     & ael**2/us*mz**2-16*qel**2*vmael**2-8*qel**2*vmael**2*ts/us**2*mz*
     & *2+8*qel**2*vmael**2*ts**2/us**2)
     & +c0irelelqs*stw**2*(-4*qel**2*qs)
     & +c0elelqscelc*dreal(propizqs)*stw**4*cfscheme*(16*ctw**2*qel**4/t
     & s**2*us**2-32*ctw**2*qel**4+16*ctw**2*qel**4*ts**2/us**2)
     & +c0irelelts*stw**2*(-4*qel**2*ts)
     & +c0irelelus*stw**2*(4*qel**2*us)
     & +c0celtsczel*stw**2*(4*qel**2*ts)
     & +c0celtsczel*dreal(propizqs)*stw**2*(4*qel**2*ts/us**2*mz**2+4*qe
     & l**2*ts/us-4*qel**2*ts**2/us**2-8*qel**2*vmael*ts/us**2*mz**2-8*q
     & el**2*vmael*ts/us+8*qel**2*vmael*ts**2/us**2+8*qel**2*vmael**2*ts
     & /us**2*mz**2+8*qel**2*vmael**2*ts/us-8*qel**2*vmael**2*ts**2/us**
     & 2)
     & +c0celusczel*stw**2*(-4*qel**2*us)
     & +c0celusczel*dreal(propizqs)*stw**2*(-8*qel**2*vmael/ts**2*us*mz*
     & *2+8*qel**2*vmael/ts**2*us**2-8*qel**2*vmael/ts*us+8*qel**2*vmael
     & **2/ts**2*us*mz**2-8*qel**2*vmael**2/ts**2*us**2+8*qel**2*vmael**
     & 2/ts*us)
     & +a0fel*stw**2*(-6*qel**2)
     & +b0fqszc*dreal(propizqs)*stw**2*(-4*qel**2/us+8*qel**2*vmael/ts+8
     & *qel**2*vmael/us-8*qel**2*vmael**2/ts-8*qel**2*vmael**2/us)
     & +b0fqscc*stw**2*(-6*qel**2)
     & +b0fqscc*dreal(propizqs)*stw**4*cfscheme*(-16*ctw**2*qel**4/ts-16
     & *ctw**2*qel**4/us)
     & +b0ftscc*dreal(propizqs)*stw**2*(4*qel**2/us-8*qel**2*vmael/us+8*
     & qel**2*vmael**2/us)
     & +b0ftscc*dreal(propizqs)*stw**4*cfscheme*(16*ctw**2*qel**4/us)
     & +b0fuscc*dreal(propizqs)*stw**2*(-8*qel**2*vmael/ts+8*qel**2*vmae
     & l**2/ts)
     & +b0fuscc*dreal(propizqs)*stw**4*cfscheme*(16*ctw**2*qel**4/ts)
     & +lnlaelm*stw**2*(4*qel**2)

      ff_qed_ql =
     & +stw**2*(-2*qel**2)
     & +jaaqstselel*dreal(propizqs)*stw**2*cfscheme*(-2*ctw**2*qel**3*ts
     & /us+2*ctw**2*qel**3*ts**2/us**2)
     & +jaaqsuselel*dreal(propizqs)*stw**2*cfscheme*(2*ctw**2*qel**3/ts*
     & *2*us**2-2*ctw**2*qel**3/ts*us)
     & +javqstselelz*stw**2*(4*qel**2*ts)
     & +javqstselelz*dreal(propizqs)*stw**2*(2*qel**2*vmael*ts/us**2*mz*
     & *2+2*qel**2*vmael*ts/us-2*qel**2*vmael*ts**2/us**2)
     & +javqsuselelz*stw**2*(-4*qel**2*us)
     & +javqsuselelz*dreal(propizqs)*stw**2*(-2*qel**2/ts**2*us*mz**2+2*
     & qel**2/ts**2*us**2-2*qel**2/ts*us+2*qel**2*vmael/ts**2*us*mz**2-2
     & *qel**2*vmael/ts**2*us**2+2*qel**2*vmael/ts*us)
     & +c0elelqszelc*dreal(propizqs)*stw**2*(4*qel**2/ts**2*us*mz**2-4*q
     & el**2/ts**2*us**2+4*qel**2/ts*mz**2+4*qel**2-4*qel**2*vmael/ts**2
     & *us*mz**2+4*qel**2*vmael/ts**2*us**2-4*qel**2*vmael/ts*mz**2-4*qe
     & l**2*vmael/us*mz**2-8*qel**2*vmael-4*qel**2*vmael*ts/us**2*mz**2+
     & 4*qel**2*vmael*ts**2/us**2)
     & +c0irelelqs*stw**2*(-4*qel**2*qs)
     & +c0elelqscelc*dreal(propizqs)*stw**2*cfscheme*(-4*ctw**2*qel**3/t
     & s**2*us**2+8*ctw**2*qel**3-4*ctw**2*qel**3*ts**2/us**2)
     & +c0irelelts*stw**2*(-4*qel**2*ts)
     & +c0irelelus*stw**2*(4*qel**2*us)
     & +c0celtsczel*stw**2*(4*qel**2*ts)
     & +c0celtsczel*dreal(propizqs)*stw**2*(4*qel**2*vmael*ts/us**2*mz**
     & 2+4*qel**2*vmael*ts/us-4*qel**2*vmael*ts**2/us**2)
     & +c0celusczel*stw**2*(-4*qel**2*us)
     & +c0celusczel*dreal(propizqs)*stw**2*(-4*qel**2/ts**2*us*mz**2+4*q
     & el**2/ts**2*us**2-4*qel**2/ts*us+4*qel**2*vmael/ts**2*us*mz**2-4*
     & qel**2*vmael/ts**2*us**2+4*qel**2*vmael/ts*us)
     & +a0fel*stw**2*(-6*qel**2)
     & +b0fqszc*dreal(propizqs)*stw**2*(4*qel**2/ts-4*qel**2*vmael/ts-4*
     & qel**2*vmael/us)
     & +b0fqscc*stw**2*(-6*qel**2)
     & +b0fqscc*dreal(propizqs)*stw**2*cfscheme*(4*ctw**2*qel**3/ts+4*ct
     & w**2*qel**3/us)
     & +b0ftscc*dreal(propizqs)*stw**2*(4*qel**2*vmael/us)
     & +b0ftscc*dreal(propizqs)*stw**2*cfscheme*(-4*ctw**2*qel**3/us)
     & +b0fuscc*dreal(propizqs)*stw**2*(-4*qel**2/ts+4*qel**2*vmael/ts)
     & +b0fuscc*dreal(propizqs)*stw**2*cfscheme*(-4*ctw**2*qel**3/ts)
     & +lnlaelm*stw**2*(4*qel**2)

      ff_qed_lq =
     & +stw**2*(-2*qel**2)
     & +jaaqstselel*dreal(propizqs)*stw**2*cfscheme*(-2*ctw**2*qel**3*ts
     & /us+2*ctw**2*qel**3*ts**2/us**2)
     & +jaaqsuselel*dreal(propizqs)*stw**2*cfscheme*(2*ctw**2*qel**3/ts*
     & *2*us**2-2*ctw**2*qel**3/ts*us)
     & +javqstselelz*stw**2*(4*qel**2*ts)
     & +javqstselelz*dreal(propizqs)*stw**2*(2*qel**2*vmael*ts/us**2*mz*
     & *2+2*qel**2*vmael*ts/us-2*qel**2*vmael*ts**2/us**2)
     & +javqsuselelz*stw**2*(-4*qel**2*us)
     & +javqsuselelz*dreal(propizqs)*stw**2*(-2*qel**2/ts**2*us*mz**2+2*
     & qel**2/ts**2*us**2-2*qel**2/ts*us+2*qel**2*vmael/ts**2*us*mz**2-2
     & *qel**2*vmael/ts**2*us**2+2*qel**2*vmael/ts*us)
     & +c0elelqszelc*dreal(propizqs)*stw**2*(4*qel**2/ts**2*us*mz**2-4*q
     & el**2/ts**2*us**2+4*qel**2/ts*mz**2+4*qel**2-4*qel**2*vmael/ts**2
     & *us*mz**2+4*qel**2*vmael/ts**2*us**2-4*qel**2*vmael/ts*mz**2-4*qe
     & l**2*vmael/us*mz**2-8*qel**2*vmael-4*qel**2*vmael*ts/us**2*mz**2+
     & 4*qel**2*vmael*ts**2/us**2)
     & +c0irelelqs*stw**2*(-4*qel**2*qs)
     & +c0elelqscelc*dreal(propizqs)*stw**2*cfscheme*(-4*ctw**2*qel**3/t
     & s**2*us**2+8*ctw**2*qel**3-4*ctw**2*qel**3*ts**2/us**2)
     & +c0irelelts*stw**2*(-4*qel**2*ts)
     & +c0irelelus*stw**2*(4*qel**2*us)
     & +c0celtsczel*stw**2*(4*qel**2*ts)
     & +c0celtsczel*dreal(propizqs)*stw**2*(4*qel**2*vmael*ts/us**2*mz**
     & 2+4*qel**2*vmael*ts/us-4*qel**2*vmael*ts**2/us**2)
     & +c0celusczel*stw**2*(-4*qel**2*us)
     & +c0celusczel*dreal(propizqs)*stw**2*(-4*qel**2/ts**2*us*mz**2+4*q
     & el**2/ts**2*us**2-4*qel**2/ts*us+4*qel**2*vmael/ts**2*us*mz**2-4*
     & qel**2*vmael/ts**2*us**2+4*qel**2*vmael/ts*us)
     & +a0fel*stw**2*(-6*qel**2)
     & +b0fqszc*dreal(propizqs)*stw**2*(4*qel**2/ts-4*qel**2*vmael/ts-4*
     & qel**2*vmael/us)
     & +b0fqscc*stw**2*(-6*qel**2)
     & +b0fqscc*dreal(propizqs)*stw**2*cfscheme*(4*ctw**2*qel**3/ts+4*ct
     & w**2*qel**3/us)
     & +b0ftscc*dreal(propizqs)*stw**2*(4*qel**2*vmael/us)
     & +b0ftscc*dreal(propizqs)*stw**2*cfscheme*(-4*ctw**2*qel**3/us)
     & +b0fuscc*dreal(propizqs)*stw**2*(-4*qel**2/ts+4*qel**2*vmael/ts)
     & +b0fuscc*dreal(propizqs)*stw**2*cfscheme*(-4*ctw**2*qel**3/ts)
     & +lnlaelm*stw**2*(4*qel**2)

      ff_qed_qq =
     & +stw**2*(-2*qel**2)
     & +propizqs*c0irelelqs*cfscheme*(-4*ctw**2*qel**2)
     & +propizqs*c0irelelts*cfscheme*(-4*ctw**2*qel**2/qs*ts)
     & +propizqs*c0irelelus*cfscheme*(4*ctw**2*qel**2/qs*us)
     & +propizqs*lnlaelm*cfscheme*(4*ctw**2*qel**2/qs)
     & +jaaqstselel*dreal(propizqs)*cfscheme*(2*ctw**2*qel**2/qs*ts+ctw*
     & *2*qel**2*ts/us-ctw**2*qel**2*ts**2/us**2)
     & +jaaqsuselel*dreal(propizqs)*cfscheme*(-2*ctw**2*qel**2/qs*us)
     & +javqstselelz*stw**2*(4*qel**2*ts)
     & +javqstselelz*dreal(propizqs)*stw**2*(2*qel**2*ts/us**2*mz**2+2*q
     & el**2*ts/us-2*qel**2*ts**2/us**2)
     & +javqsuselelz*stw**2*(-4*qel**2*us)
     & +c0elelqszelc*dreal(propizqs)*stw**2*(-4*qel**2/us*mz**2-4*qel**2
     & -4*qel**2*ts/us**2*mz**2+4*qel**2*ts**2/us**2)
     & +c0irelelqs*stw**2*(-4*qel**2*qs)
     & +c0elelqscelc*dreal(propizqs)*cfscheme*(-2*ctw**2*qel**2+2*ctw**2
     & *qel**2*ts**2/us**2)
     & +c0irelelts*stw**2*(-4*qel**2*ts)
     & +c0irelelus*stw**2*(4*qel**2*us)
     & +c0celtsczel*stw**2*(4*qel**2*ts)
     & +c0celtsczel*dreal(propizqs)*stw**2*(4*qel**2*ts/us**2*mz**2+4*qe
     & l**2*ts/us-4*qel**2*ts**2/us**2)
     & +c0celusczel*stw**2*(-4*qel**2*us)
     & +a0fel*stw**2*(-6*qel**2)
     & +a0fel*dreal(propizqs)*cfscheme*(-6*ctw**2*qel**2/qs)
     & +b0fqszc*dreal(propizqs)*stw**2*(-4*qel**2/us)
     & +b0fqscc*stw**2*(-6*qel**2)
     & +b0fqscc*dreal(propizqs)*cfscheme*(-6*ctw**2*qel**2/qs-2*ctw**2*q
     & el**2/us)
     & +b0ftscc*dreal(propizqs)*cfscheme*(2*ctw**2*qel**2/us)
     & +b0ftscc*dreal(propizqs)*stw**2*(4*qel**2/us)
     & +lnlaelm*stw**2*(4*qel**2)
     & +dreal(propizqs)*cfscheme*(-2*ctw**2*qel**2/qs)

      ff_qed_ld =
     & 0

      ff_qed_qd =
     & 0

      ff_ew_ll =
     & +1d0/stw**2*(deltarhofer+deltarhobos)
     & +d0ccccqstswcwc*dreal(propizqs)*(-2/us*mw**4*rwz-4*ts/us**2*mw**4
     & *rwz-ts*rwz+4*ts**2/us**2*mw**2*rwz-ts**3/us**2*rwz)
     & +d0ccccqstszczc*dreal(propizqs)*(-1d0/2/ctw**2*mz**2+1d0/8/ctw**2
     & *us-1d0/2/ctw**2*ts-1d0/8/ctw**2*ts**2/us+2/ctw**2*vmael*mz**2-1d
     & 0/2/ctw**2*vmael*us+2/ctw**2*vmael*ts+1d0/2/ctw**2*vmael*ts**2/us
     & -3/ctw**2*vmael**2*mz**2+3d0/4/ctw**2*vmael**2*us-2/ctw**2*vmael*
     & *2*ts-3d0/4/ctw**2*vmael**2*ts**2/us+2/ctw**2*vmael**3*mz**2-1d0/
     & 2/ctw**2*vmael**3*us+1d0/2/ctw**2*vmael**3*ts**2/us-1d0/ctw**2*vm
     & ael**4*mz**2+1d0/4/ctw**2*vmael**4*us-1d0/4/ctw**2*vmael**4*ts**2
     & /us-3d0/4*pxx2zqsc/ctw**2*ts/us+3*pxx2zqsc/ctw**2*vmael*ts/us-9d0
     & /2*pxx2zqsc/ctw**2*vmael**2*ts/us+3*pxx2zqsc/ctw**2*vmael**3*ts/u
     & s-3d0/2*pxx2zqsc/ctw**2*vmael**4*ts/us-1d0/8*pxx2zqsc**2/ctw**2/u
     & s-1d0/4*pxx2zqsc**2/ctw**2*ts/us**2+1d0/2*pxx2zqsc**2/ctw**2*vmae
     & l/us+pxx2zqsc**2/ctw**2*vmael*ts/us**2-3d0/4*pxx2zqsc**2/ctw**2*v
     & mael**2/us-3d0/2*pxx2zqsc**2/ctw**2*vmael**2*ts/us**2+1d0/2*pxx2z
     & qsc**2/ctw**2*vmael**3/us+pxx2zqsc**2/ctw**2*vmael**3*ts/us**2-1d
     & 0/4*pxx2zqsc**2/ctw**2*vmael**4/us-1d0/2*pxx2zqsc**2/ctw**2*vmael
     & **4*ts/us**2)
     & +d0ccccqsuszczc*dreal(propizqs)*(1d0/2/ctw**2*us-2/ctw**2*vmael*u
     & s-1d0/4/ctw**2*vmael**2/ts*us**2+3d0/2/ctw**2*vmael**2*us-1d0/4/c
     & tw**2*vmael**2*ts+1d0/2/ctw**2*vmael**3/ts*us**2+1d0/ctw**2*vmael
     & **3*us+1d0/2/ctw**2*vmael**3*ts-1d0/4/ctw**2*vmael**4/ts*us**2-1d
     & 0/2/ctw**2*vmael**4*us-1d0/4/ctw**2*vmael**4*ts-3d0/2*pxx2zqsc/ct
     & w**2*vmael**2/ts*us-1d0/2*pxx2zqsc/ctw**2*vmael**2+3*pxx2zqsc/ctw
     & **2*vmael**3/ts*us+pxx2zqsc/ctw**2*vmael**3-3d0/2*pxx2zqsc/ctw**2
     & *vmael**4/ts*us-1d0/2*pxx2zqsc/ctw**2*vmael**4-1d0/2*pxx2zqsc**2/
     & ctw**2*vmael**2/ts**2*us-1d0/4*pxx2zqsc**2/ctw**2*vmael**2/ts+pxx
     & 2zqsc**2/ctw**2*vmael**3/ts**2*us+1d0/2*pxx2zqsc**2/ctw**2*vmael*
     & *3/ts-1d0/2*pxx2zqsc**2/ctw**2*vmael**4/ts**2*us-1d0/4*pxx2zqsc**
     & 2/ctw**2*vmael**4/ts)
     & +c0ccqswcw*dreal(propizqs)*(-4/us*mw**2*rwz+2*rwz-4*ts/us**2*mw**
     & 2*rwz+2*ts**2/us**2*rwz)
     & +c0ccqswcw*(4/qs*mw**4*rwz-8*mw**2*rwz)
     & +c0ccqszcz*dreal(propizqs)*(-1d0/ctw**2-1d0/ctw**2*ts/us+4/ctw**2
     & *vmael+4/ctw**2*vmael*ts/us-2/ctw**2*vmael**2/ts*us-8/ctw**2*vmae
     & l**2-6/ctw**2*vmael**2*ts/us+4/ctw**2*vmael**3/ts*us+8/ctw**2*vma
     & el**3+4/ctw**2*vmael**3*ts/us-2/ctw**2*vmael**4/ts*us-4/ctw**2*vm
     & ael**4-2/ctw**2*vmael**4*ts/us-1d0/2*pxx2zqsc/ctw**2/us-1d0/2*pxx
     & 2zqsc/ctw**2*ts/us**2+2*pxx2zqsc/ctw**2*vmael/us+2*pxx2zqsc/ctw**
     & 2*vmael*ts/us**2-pxx2zqsc/ctw**2*vmael**2/ts**2*us-pxx2zqsc/ctw**
     & 2*vmael**2/ts-3*pxx2zqsc/ctw**2*vmael**2/us-3*pxx2zqsc/ctw**2*vma
     & el**2*ts/us**2+2*pxx2zqsc/ctw**2*vmael**3/ts**2*us+2*pxx2zqsc/ctw
     & **2*vmael**3/ts+2*pxx2zqsc/ctw**2*vmael**3/us+2*pxx2zqsc/ctw**2*v
     & mael**3*ts/us**2-pxx2zqsc/ctw**2*vmael**4/ts**2*us-pxx2zqsc/ctw**
     & 2*vmael**4/ts-pxx2zqsc/ctw**2*vmael**4/us-pxx2zqsc/ctw**2*vmael**
     & 4*ts/us**2)
     & +c0ccqscwc*(2/qs*mw**4-4*mw**2+2*qs)
     & +c0ccqsczc*(-7/qs*mw**4/rwz**3+18/qs*mw**4/rwz**2-12/qs*mw**4/rwz
     & +14*mw**2/rwz**2-36*mw**2/rwz+24*mw**2-7*qs/rwz+18*qs-12*qs*rwz)
     & +c0cctscwc*dreal(propizqs)*(4*ts/us**2*mw**2*rwz+2*ts/us*rwz-2*ts
     & **2/us**2*rwz)
     & +c0cctsczc*dreal(propizqs)*(1d0/ctw**2*ts/us-4/ctw**2*vmael*ts/us
     & +6/ctw**2*vmael**2*ts/us-4/ctw**2*vmael**3*ts/us+2/ctw**2*vmael**
     & 4*ts/us+1d0/2*pxx2zqsc/ctw**2*ts/us**2-2*pxx2zqsc/ctw**2*vmael*ts
     & /us**2+3*pxx2zqsc/ctw**2*vmael**2*ts/us**2-2*pxx2zqsc/ctw**2*vmae
     & l**3*ts/us**2+pxx2zqsc/ctw**2*vmael**4*ts/us**2)
     & +c0ccusczc*dreal(propizqs)*(2/ctw**2*vmael**2/ts*us-4/ctw**2*vmae
     & l**3/ts*us+2/ctw**2*vmael**4/ts*us+pxx2zqsc/ctw**2*vmael**2/ts**2
     & *us-2*pxx2zqsc/ctw**2*vmael**3/ts**2*us+pxx2zqsc/ctw**2*vmael**4/
     & ts**2*us)
     & +a0fw*dreal(propzqs)*(3*mw**2/rwz/rhw+1d0/6*mw**2/rwz-8d0/3*mw**2
     & -4*mw**2*rwz)
     & +a0fw*(3-2/qs*mw**2+4/qs*mw**2*rwz-2*rwz)
     & +a0fz*dreal(propzqs)*(3d0/2*mw**2/rwz**3/rhw+1d0/6*mw**2/rwz**2-1
     & d0/12*mw**2/rwz*rhw)
     & +a0fz*(27+83d0/12/qs*mw**2/rwz**2-18/qs*mw**2/rwz+1d0/12/qs*mw**2
     & /rwz*rhw+12/qs*mw**2-21d0/2/rwz-18*rwz)
     & +a0fh*dreal(propzqs)*(1d0/2*mw**2/rwz*rhw+1d0/12*mw**2*rhw**2)
     & +a0fh*(1d0/12/qs*mw**2/rwz*rhw-1d0/12/qs*mw**2*rhw**2)
     & +b0fqsww*dreal(propzqs)*(1d0/12*mw**2/rwz**2+4d0/3*mw**2/rwz-17d0
     & /3*mw**2-4*mw**2*rwz)
     & +b0fqsww*dreal(propizqs)*(-2/us*rwz+5d0/3/mw**2*rwz-1d0/12*qs/mw*
     & *4*rwz)
     & +b0fqsww*(-4d0/3+4/qs*mw**2*rwz-1d0/12/rwz+rwz+1d0/12*qs/mw**2-5d
     & 0/3*qs/mw**2*rwz+1d0/12*qs**2/mw**4*rwz)
     & +b0fqszz*dreal(propizqs)*(-1d0/2/ctw**2/us+2/ctw**2*vmael/us-1d0/
     & ctw**2*vmael**2/ts-3/ctw**2*vmael**2/us+2/ctw**2*vmael**3/ts+2/ct
     & w**2*vmael**3/us-1d0/ctw**2*vmael**4/ts-1d0/ctw**2*vmael**4/us)
     & +b0fqszh*dreal(propzqs)*(mw**2/rwz**2-1d0/3*mw**2/rwz*rhw+1d0/12*
     & mw**2*rhw**2)
     & +b0fqszh*(-1d0/12/qs*mw**2/rwz**2+1d0/6/qs*mw**2/rwz*rhw-1d0/12/q
     & s*mw**2*rhw**2-1d0/12/rwz)
     & +b0fqscc*(30+7/qs*mw**2/rwz**2-18/qs*mw**2/rwz+10/qs*mw**2-21d0/2
     & /rwz-18*rwz)
     & +b0ftscc*dreal(propizqs)*(1d0/2/ctw**2/us-2/ctw**2*vmael/us+3/ctw
     & **2*vmael**2/us-2/ctw**2*vmael**3/us+1d0/ctw**2*vmael**4/us+2/us*
     & rwz)
     & +b0fuscc*dreal(propizqs)*(1d0/ctw**2*vmael**2/ts-2/ctw**2*vmael**
     & 3/ts+1d0/ctw**2*vmael**4/ts)
     & +dreal(propzqs)*(mw**2/rwz**3/rhw-1d0/18*mw**2/rwz**2+2*mw**2/rwz
     & /rhw-5d0/9*mw**2/rwz-mw**2/rwz*zmzzzbos-1d0/6*mw**2/rwz*rhw-8d0/3
     & *mw**2-4*mw**2*rwz)
     & +47d0/9-67d0/36/rwz+caldzfer-2*deltarhofer-za1fer-2*deltarhobos-z
     & a1bos+4*rwz

      ff_ew_ql =
     & +d0ccccqstszczc*dreal(propizqs)*(1d0/2/ctw**2*vmael*ts-1d0/ctw**2
     & *vmael**2*ts-1d0/2/ctw**2*vmael**3*mz**2+1d0/8/ctw**2*vmael**3*us
     & -1d0/8/ctw**2*vmael**3*ts**2/us-3d0/4*pxx2zqsc/ctw**2*vmael**3*ts
     & /us-1d0/8*pxx2zqsc**2/ctw**2*vmael**3/us-1d0/4*pxx2zqsc**2/ctw**2
     & *vmael**3*ts/us**2)
     & +d0ccccqsuszczc*dreal(propizqs)*(-1d0/8/ctw**2*vmael/ts*us**2-3d0
     & /4/ctw**2*vmael*us-1d0/8/ctw**2*vmael*ts+1d0/4/ctw**2*vmael**2/ts
     & *us**2+3d0/2/ctw**2*vmael**2*us+1d0/4/ctw**2*vmael**2*ts-1d0/8/ct
     & w**2*vmael**3/ts*us**2-1d0/4/ctw**2*vmael**3*us-1d0/8/ctw**2*vmae
     & l**3*ts-3d0/4*pxx2zqsc/ctw**2*vmael/ts*us-1d0/4*pxx2zqsc/ctw**2*v
     & mael+3d0/2*pxx2zqsc/ctw**2*vmael**2/ts*us+1d0/2*pxx2zqsc/ctw**2*v
     & mael**2-3d0/4*pxx2zqsc/ctw**2*vmael**3/ts*us-1d0/4*pxx2zqsc/ctw**
     & 2*vmael**3-1d0/4*pxx2zqsc**2/ctw**2*vmael/ts**2*us-1d0/8*pxx2zqsc
     & **2/ctw**2*vmael/ts+1d0/2*pxx2zqsc**2/ctw**2*vmael**2/ts**2*us+1d
     & 0/4*pxx2zqsc**2/ctw**2*vmael**2/ts-1d0/4*pxx2zqsc**2/ctw**2*vmael
     & **3/ts**2*us-1d0/8*pxx2zqsc**2/ctw**2*vmael**3/ts)
     & +c0ccqswcw*(-2/qs**2*mw**6+4/qs*mw**4)
     & +c0ccqszcz*dreal(propizqs)*(-1d0/ctw**2*vmael/ts*us-1d0/ctw**2*vm
     & ael+2/ctw**2*vmael**2/ts*us+2/ctw**2*vmael**2-1d0/ctw**2*vmael**3
     & /ts*us-2/ctw**2*vmael**3-1d0/ctw**2*vmael**3*ts/us-1d0/2*pxx2zqsc
     & /ctw**2*vmael/ts**2*us-1d0/2*pxx2zqsc/ctw**2*vmael/ts+pxx2zqsc/ct
     & w**2*vmael**2/ts**2*us+pxx2zqsc/ctw**2*vmael**2/ts-1d0/2*pxx2zqsc
     & /ctw**2*vmael**3/ts**2*us-1d0/2*pxx2zqsc/ctw**2*vmael**3/ts-1d0/2
     & *pxx2zqsc/ctw**2*vmael**3/us-1d0/2*pxx2zqsc/ctw**2*vmael**3*ts/us
     & **2)
     & +c0ccqscwc*(1d0/qs*mw**4-2*mw**2+qs)
     & +c0ccqsczc*(-3/qs**2*mw**6/rwz**3+4/qs**2*mw**6/rwz**2-11d0/2/qs*
     & mw**4/rwz**3+16/qs*mw**4/rwz**2-12/qs*mw**4/rwz+11*mw**2/rwz**2-2
     & 3*mw**2/rwz+12*mw**2-11d0/2*qs/rwz+10*qs-4*qs*rwz)
     & +c0cctsczc*dreal(propizqs)*(1d0/ctw**2*vmael**3*ts/us+1d0/2*pxx2z
     & qsc/ctw**2*vmael**3*ts/us**2)
     & +c0ccusczc*dreal(propizqs)*(1d0/ctw**2*vmael/ts*us-2/ctw**2*vmael
     & **2/ts*us+1d0/ctw**2*vmael**3/ts*us+1d0/2*pxx2zqsc/ctw**2*vmael/t
     & s**2*us-pxx2zqsc/ctw**2*vmael**2/ts**2*us+1d0/2*pxx2zqsc/ctw**2*v
     & mael**3/ts**2*us)
     & +a0fw*dreal(propzqs)*(3*mw**2/rwz/rhw+1d0/6*mw**2/rwz-8d0/3*mw**2
     & -4*mw**2*rwz)
     & +a0fw*(3d0/2-2/qs**2*mw**4+4d0/3/qs*mw**2+4/qs*mw**2*rwz)
     & +a0fz*dreal(propzqs)*(3d0/2*mw**2/rwz**3/rhw+1d0/6*mw**2/rwz**2-1
     & d0/12*mw**2/rwz*rhw)
     & +a0fz*(15+3/qs**2*mw**4/rwz**2-4/qs**2*mw**4/rwz+65d0/12/qs*mw**2
     & /rwz**2-29d0/2/qs*mw**2/rwz+1d0/12/qs*mw**2/rwz*rhw+10/qs*mw**2-3
     & 3d0/4/rwz-6*rwz)
     & +a0fh*dreal(propzqs)*(1d0/2*mw**2/rwz*rhw+1d0/12*mw**2*rhw**2)
     & +a0fh*(1d0/12/qs*mw**2/rwz*rhw-1d0/12/qs*mw**2*rhw**2)
     & +b0fqsww*dreal(propzqs)*(1d0/12*mw**2/rwz**2+4d0/3*mw**2/rwz-17d0
     & /3*mw**2-4*mw**2*rwz)
     & +b0fqsww*(1d0/6-2/qs**2*mw**4+7d0/3/qs*mw**2+4/qs*mw**2*rwz-1d0/1
     & 2/rwz)
     & +b0fqszz*dreal(propizqs)*(-1d0/2/ctw**2*vmael/ts+1d0/ctw**2*vmael
     & **2/ts-1d0/2/ctw**2*vmael**3/ts-1d0/2/ctw**2*vmael**3/us)
     & +b0fqszh*dreal(propzqs)*(mw**2/rwz**2-1d0/3*mw**2/rwz*rhw+1d0/12*
     & mw**2*rhw**2)
     & +b0fqszh*(-1d0/12/qs*mw**2/rwz**2+1d0/6/qs*mw**2/rwz*rhw-1d0/12/q
     & s*mw**2*rhw**2-1d0/12/rwz)
     & +b0fqscc*(33d0/2+3/qs**2*mw**4/rwz**2-4/qs**2*mw**4/rwz+11d0/2/qs
     & *mw**2/rwz**2-29d0/2/qs*mw**2/rwz+9/qs*mw**2-33d0/4/rwz-6*rwz)
     & +b0ftscc*dreal(propizqs)*(1d0/2/ctw**2*vmael**3/us)
     & +b0fuscc*dreal(propizqs)*(1d0/2/ctw**2*vmael/ts-1d0/ctw**2*vmael*
     & *2/ts+1d0/2/ctw**2*vmael**3/ts)
     & +dreal(propzqs)*(mw**2/rwz**3/rhw-1d0/18*mw**2/rwz**2+2*mw**2/rwz
     & /rhw-5d0/9*mw**2/rwz-mw**2/rwz*zmzzzbos-1d0/6*mw**2/rwz*rhw-8d0/3
     & *mw**2-4*mw**2*rwz)
     & +103d0/36-3d0/4/qs*mw**2/rwz-7d0/6/qs*mw**2+4/qs*mw**2*rwz-107d0/
     & 72/rwz-pizgfer+caldzfer-deltarhofer-za1fer-deltarhobos-za1bos-rwz
     & 

      ff_ew_lq =
     & +d0ccccqstszczc*dreal(propizqs)*(1d0/2/ctw**2*vmael*ts-1d0/ctw**2
     & *vmael**2*ts-1d0/2/ctw**2*vmael**3*mz**2+1d0/8/ctw**2*vmael**3*us
     & -1d0/8/ctw**2*vmael**3*ts**2/us-3d0/4*pxx2zqsc/ctw**2*vmael**3*ts
     & /us-1d0/8*pxx2zqsc**2/ctw**2*vmael**3/us-1d0/4*pxx2zqsc**2/ctw**2
     & *vmael**3*ts/us**2)
     & +d0ccccqsuszczc*dreal(propizqs)*(-1d0/8/ctw**2*vmael/ts*us**2-3d0
     & /4/ctw**2*vmael*us-1d0/8/ctw**2*vmael*ts+1d0/4/ctw**2*vmael**2/ts
     & *us**2+3d0/2/ctw**2*vmael**2*us+1d0/4/ctw**2*vmael**2*ts-1d0/8/ct
     & w**2*vmael**3/ts*us**2-1d0/4/ctw**2*vmael**3*us-1d0/8/ctw**2*vmae
     & l**3*ts-3d0/4*pxx2zqsc/ctw**2*vmael/ts*us-1d0/4*pxx2zqsc/ctw**2*v
     & mael+3d0/2*pxx2zqsc/ctw**2*vmael**2/ts*us+1d0/2*pxx2zqsc/ctw**2*v
     & mael**2-3d0/4*pxx2zqsc/ctw**2*vmael**3/ts*us-1d0/4*pxx2zqsc/ctw**
     & 2*vmael**3-1d0/4*pxx2zqsc**2/ctw**2*vmael/ts**2*us-1d0/8*pxx2zqsc
     & **2/ctw**2*vmael/ts+1d0/2*pxx2zqsc**2/ctw**2*vmael**2/ts**2*us+1d
     & 0/4*pxx2zqsc**2/ctw**2*vmael**2/ts-1d0/4*pxx2zqsc**2/ctw**2*vmael
     & **3/ts**2*us-1d0/8*pxx2zqsc**2/ctw**2*vmael**3/ts)
     & +c0ccqswcw*(-2/qs**2*mw**6+4/qs*mw**4)
     & +c0ccqszcz*dreal(propizqs)*(-1d0/ctw**2*vmael/ts*us-1d0/ctw**2*vm
     & ael+2/ctw**2*vmael**2/ts*us+2/ctw**2*vmael**2-1d0/ctw**2*vmael**3
     & /ts*us-2/ctw**2*vmael**3-1d0/ctw**2*vmael**3*ts/us-1d0/2*pxx2zqsc
     & /ctw**2*vmael/ts**2*us-1d0/2*pxx2zqsc/ctw**2*vmael/ts+pxx2zqsc/ct
     & w**2*vmael**2/ts**2*us+pxx2zqsc/ctw**2*vmael**2/ts-1d0/2*pxx2zqsc
     & /ctw**2*vmael**3/ts**2*us-1d0/2*pxx2zqsc/ctw**2*vmael**3/ts-1d0/2
     & *pxx2zqsc/ctw**2*vmael**3/us-1d0/2*pxx2zqsc/ctw**2*vmael**3*ts/us
     & **2)
     & +c0ccqscwc*(1d0/qs*mw**4-2*mw**2+qs)
     & +c0ccqsczc*(-3/qs**2*mw**6/rwz**3+4/qs**2*mw**6/rwz**2-11d0/2/qs*
     & mw**4/rwz**3+16/qs*mw**4/rwz**2-12/qs*mw**4/rwz+11*mw**2/rwz**2-2
     & 3*mw**2/rwz+12*mw**2-11d0/2*qs/rwz+10*qs-4*qs*rwz)
     & +c0cctsczc*dreal(propizqs)*(1d0/ctw**2*vmael**3*ts/us+1d0/2*pxx2z
     & qsc/ctw**2*vmael**3*ts/us**2)
     & +c0ccusczc*dreal(propizqs)*(1d0/ctw**2*vmael/ts*us-2/ctw**2*vmael
     & **2/ts*us+1d0/ctw**2*vmael**3/ts*us+1d0/2*pxx2zqsc/ctw**2*vmael/t
     & s**2*us-pxx2zqsc/ctw**2*vmael**2/ts**2*us+1d0/2*pxx2zqsc/ctw**2*v
     & mael**3/ts**2*us)
     & +a0fw*dreal(propzqs)*(3*mw**2/rwz/rhw+1d0/6*mw**2/rwz-8d0/3*mw**2
     & -4*mw**2*rwz)
     & +a0fw*(3d0/2-2/qs**2*mw**4+4d0/3/qs*mw**2+4/qs*mw**2*rwz)
     & +a0fz*dreal(propzqs)*(3d0/2*mw**2/rwz**3/rhw+1d0/6*mw**2/rwz**2-1
     & d0/12*mw**2/rwz*rhw)
     & +a0fz*(15+3/qs**2*mw**4/rwz**2-4/qs**2*mw**4/rwz+65d0/12/qs*mw**2
     & /rwz**2-29d0/2/qs*mw**2/rwz+1d0/12/qs*mw**2/rwz*rhw+10/qs*mw**2-3
     & 3d0/4/rwz-6*rwz)
     & +a0fh*dreal(propzqs)*(1d0/2*mw**2/rwz*rhw+1d0/12*mw**2*rhw**2)
     & +a0fh*(1d0/12/qs*mw**2/rwz*rhw-1d0/12/qs*mw**2*rhw**2)
     & +b0fqsww*dreal(propzqs)*(1d0/12*mw**2/rwz**2+4d0/3*mw**2/rwz-17d0
     & /3*mw**2-4*mw**2*rwz)
     & +b0fqsww*(1d0/6-2/qs**2*mw**4+7d0/3/qs*mw**2+4/qs*mw**2*rwz-1d0/1
     & 2/rwz)
     & +b0fqszz*dreal(propizqs)*(-1d0/2/ctw**2*vmael/ts+1d0/ctw**2*vmael
     & **2/ts-1d0/2/ctw**2*vmael**3/ts-1d0/2/ctw**2*vmael**3/us)
     & +b0fqszh*dreal(propzqs)*(mw**2/rwz**2-1d0/3*mw**2/rwz*rhw+1d0/12*
     & mw**2*rhw**2)
     & +b0fqszh*(-1d0/12/qs*mw**2/rwz**2+1d0/6/qs*mw**2/rwz*rhw-1d0/12/q
     & s*mw**2*rhw**2-1d0/12/rwz)
     & +b0fqscc*(33d0/2+3/qs**2*mw**4/rwz**2-4/qs**2*mw**4/rwz+11d0/2/qs
     & *mw**2/rwz**2-29d0/2/qs*mw**2/rwz+9/qs*mw**2-33d0/4/rwz-6*rwz)
     & +b0ftscc*dreal(propizqs)*(1d0/2/ctw**2*vmael**3/us)
     & +b0fuscc*dreal(propizqs)*(1d0/2/ctw**2*vmael/ts-1d0/ctw**2*vmael*
     & *2/ts+1d0/2/ctw**2*vmael**3/ts)
     & +dreal(propzqs)*(mw**2/rwz**3/rhw-1d0/18*mw**2/rwz**2+2*mw**2/rwz
     & /rhw-5d0/9*mw**2/rwz-mw**2/rwz*zmzzzbos-1d0/6*mw**2/rwz*rhw-8d0/3
     & *mw**2-4*mw**2*rwz)
     & +103d0/36-3d0/4/qs*mw**2/rwz-7d0/6/qs*mw**2+4/qs*mw**2*rwz-107d0/
     & 72/rwz-pizgfer+caldzfer-deltarhofer-za1fer-deltarhobos-za1bos-rwz
     & 

      ff_ew_qq =
     & +1d0/stw**2*(-1d0/qs*mw**2*za1bos-deltarhofer-deltarhobos-za1bos)
     & +d0ccccqstszczc*dreal(propizqs)*(-1d0/2/ctw**2*vmael**2*mz**2+1d0
     & /8/ctw**2*vmael**2*us-1d0/2/ctw**2*vmael**2*ts-1d0/8/ctw**2*vmael
     & **2*ts**2/us-3d0/4*pxx2zqsc/ctw**2*vmael**2*ts/us-1d0/8*pxx2zqsc*
     & *2/ctw**2*vmael**2/us-1d0/4*pxx2zqsc**2/ctw**2*vmael**2*ts/us**2)
     & 
     & +d0ccccqsuszczc*dreal(propizqs)*(1d0/2/ctw**2*vmael**2*us)
     & +c0ccqszcz*dreal(propizqs)*(-1d0/ctw**2*vmael**2-1d0/ctw**2*vmael
     & **2*ts/us-1d0/2*pxx2zqsc/ctw**2*vmael**2/us-1d0/2*pxx2zqsc/ctw**2
     & *vmael**2*ts/us**2)
     & +c0ccqsczc*(-4/qs**2*mw**6/rwz**3+4/qs**2*mw**6/rwz**2-4/qs*mw**4
     & /rwz**3+12/qs*mw**4/rwz**2-8/qs*mw**4/rwz+8*mw**2/rwz**2-12*mw**2
     & /rwz+4*mw**2-4*qs/rwz+4*qs)
     & +c0cctsczc*dreal(propizqs)*(1d0/ctw**2*vmael**2*ts/us+1d0/2*pxx2z
     & qsc/ctw**2*vmael**2*ts/us**2)
     & +a0fw*dreal(propzqs)*(3*mw**2/rwz/rhw+1d0/6*mw**2/rwz-8d0/3*mw**2
     & -4*mw**2*rwz)
     & +a0fw*(-4/qs**2*mw**4+8d0/3/qs*mw**2+4/qs*mw**2*rwz)
     & +a0fz*dreal(propzqs)*(3d0/2*mw**2/rwz**3/rhw+1d0/6*mw**2/rwz**2-1
     & d0/12*mw**2/rwz*rhw)
     & +a0fz*(6+4/qs**2*mw**4/rwz**2-4/qs**2*mw**4/rwz+47d0/12/qs*mw**2/
     & rwz**2-10/qs*mw**2/rwz+1d0/12/qs*mw**2/rwz*rhw+6/qs*mw**2-6/rwz)
     & +a0fh*dreal(propzqs)*(1d0/2*mw**2/rwz*rhw+1d0/12*mw**2*rhw**2)
     & +a0fh*(1d0/12/qs*mw**2/rwz*rhw-1d0/12/qs*mw**2*rhw**2)
     & +b0fqsww*dreal(propzqs)*(1d0/12*mw**2/rwz**2+4d0/3*mw**2/rwz-17d0
     & /3*mw**2-4*mw**2*rwz)
     & +b0fqsww*(-4/qs**2*mw**4+17d0/3/qs*mw**2+4/qs*mw**2*rwz-1d0/12/rw
     & z)
     & +b0fqszz*dreal(propizqs)*(-1d0/2/ctw**2*vmael**2/us)
     & +b0fqszh*dreal(propzqs)*(mw**2/rwz**2-1d0/3*mw**2/rwz*rhw+1d0/12*
     & mw**2*rhw**2)
     & +b0fqszh*(-1d0/12/qs*mw**2/rwz**2+1d0/6/qs*mw**2/rwz*rhw-1d0/12/q
     & s*mw**2*rhw**2-1d0/12/rwz)
     & +b0fqscc*(6+4/qs**2*mw**4/rwz**2-4/qs**2*mw**4/rwz+4/qs*mw**2/rwz
     & **2-10/qs*mw**2/rwz+6/qs*mw**2-6/rwz)
     & +b0ftscc*dreal(propizqs)*(1d0/2/ctw**2*vmael**2/us)
     & +dreal(propzqs)*(mw**2/rwz**3/rhw-1d0/18*mw**2/rwz**2+2*mw**2/rwz
     & /rhw-5d0/9*mw**2/rwz-mw**2/rwz*zmzzzbos-1d0/6*mw**2/rwz*rhw-8d0/3
     & *mw**2-4*mw**2*rwz)
     & +1-4/qs**2*mw**4-1d0/qs*mw**2/rwz+11d0/3/qs*mw**2+4/qs*mw**2*rwz-
     & 10d0/9/rwz-2*pizgfer+caldzfer-za1fer

      ff_ew_ld =
     & 0

      ff_ew_qd =
     & 0

      ffarray(1,1) = ff_qed_ll
      ffarray(1,2) = ff_ew_ll
      ffarray(1,3) = ff_qed_lq
      ffarray(1,4) = ff_ew_lq
      ffarray(1,5) = ff_qed_ql
      ffarray(1,6) = ff_ew_ql
      ffarray(1,7) = ff_qed_qq
      ffarray(1,8) = ff_ew_qq
      ffarray(1,9) = ff_qed_ld
      ffarray(1,10) = ff_ew_ld
      ffarray(1,11) = ff_qed_qd
      ffarray(1,12) = ff_ew_qd
      ffarray(1,13) = ff_qed_gg

      return
      end
