#include "LHEF.h"
#include "Info.h"
#include <fstream>
#include <iomanip>

using namespace std;
using namespace SANC;

#define SP12 setprecision(12) << setw(21)
#define SW18 setw(18)
#define SW3  setw(3)
#define SW6  setw(6)

LHEF::LHEF(Info & _info):info(_info)
{

}

void LHEF::LHEInit() {
    // TODO move to OF_LHEF class
    heprup.idbmup[0] = 11;
    heprup.idbmup[1] = -11;
    heprup.ebmup[0] = info.Ecm/2.0;
    heprup.ebmup[1] = info.Ecm/2.0;
    heprup.pdfgup[0] = -1;
    heprup.pdfgup[1] = -1;
    heprup.pdfsup[0] = -1;
    heprup.pdfsup[1] = -1;
    heprup.idwtup = -3;
    heprup.nprup = 1;
    heprup.xsecup = 1.0;
    heprup.xerrup = 0.0;
    heprup.xmaxup = 1.0;
    heprup.lprup = 10001;
}

void LHEF::printInit(ostream &output)
{
    LHEInit();
    output << "<LesHouchesEvents version=\"1.0\">" << '\n';
    output << "<!--" << '\n';
    output << "File generated with SANCee MC generator" << '\n';
    output << "-->" << '\n';
    output << "<init>" << '\n';
    output << SW6 << heprup.idbmup[0]<< SW6 << heprup.idbmup[1]
           << SP12 << heprup.ebmup[0] << SP12 << heprup.ebmup[1]
           << SW6 << heprup.pdfgup[0] << SW6 << heprup.pdfgup[1]
           << SW6 << heprup.pdfsup[0] << SW6 << heprup.pdfsup[1]
           << SW6 << heprup.idwtup << SW6 << heprup.nprup << '\n';
    output << SP12 << heprup.xsecup << SP12 << heprup.xerrup << SP12 << heprup.xmaxup
           << SW18 << heprup.lprup << '\n';
    output << "</init>" << '\n';
}

void LHEF::printEvent(ostream &output)
{
    output << "<event>" << '\n'
    << SW6 << hepeup.nup << SW6 << hepeup.idprup << SW6 << hepeup.xwgtup << SP12 << hepeup.scalup
    << SP12 << hepeup.aqedup << SP12 << hepeup.aqcdup << '\n';
    for (int i = 0; i < hepeup.nup; i++) {
        output << SW6 << hepeup.idup[i] << SW6 << hepeup.istup[i] << SW6 << hepeup.mothup[i][0]
        << SW6 << hepeup.mothup[i][1] << SW6 << hepeup.icolup[i][0] << SW6 << hepeup.icolup[i][1]
        << SP12 << hepeup.pup[i][0] << SP12 << hepeup.pup[i][1] << SP12 << hepeup.pup[i][2]
        << SP12 << hepeup.pup[i][3] << SP12 << hepeup.pup[i][4] << SW6 << hepeup.vtimup[i]
        << SW6 << hepeup.spinup[i] << '\n';
    }
    output << "</event>" << '\n';
}

